from selenium import webdriver
import time
import csv
from selenium.webdriver.support.ui import WebDriverWait
from selenium.webdriver.chrome.options import Options
from selenium.webdriver.common.by import By
from selenium.webdriver.common.keys import Keys
op = Options()
op.add_argument('--headless')
op.add_argument('--disable-infobars')


def get_addr(url, keywords):
    """
    访问url地址
    :param url:
    :param keywords:
    :return:
    """
    driver = webdriver.Chrome(r'E:\DownloadFile\chromedriver.exe',chrome_options=op)
    # driver = webdriver.Chrome(chrome_options=op)
    driver.get(url=url)
    print("正在请求目标网站......")
    # 等待3秒
    driver.implicitly_wait(4)
    try:
        input_keyword = driver.find_element_by_id('key')
        input_keyword.send_keys(keywords)
        input_keyword.send_keys(Keys.ENTER)
        # 休眠2秒
        time.sleep(3)
        print("准备打印目标数据,请稍等.....")
        get_book(driver)
    finally:
        driver.close()

def get_book(driver):
    """
    数据解析提取
    :param driver:
    :return:
    """
    try:
        books = driver.find_elements_by_class_name('gl-i-wrap')

        for book in books:
            book_img = book.find_element_by_css_selector('.p-img a img').get_attribute('src')
            book_url = book.find_element_by_tag_name('a').get_attribute('href')
            book_name = book.find_element_by_css_selector('.p-name em').text.replace('\n','')
            book_price = book.find_element_by_css_selector('.p-price i').text
            book_commint = book.find_element_by_css_selector('.p-commit a').text
            info = """
            名称: %s
            链接: %s
            图片: %s
            价格: %s
            评论数: %s
            """%(book_name, book_url, book_img, book_price, book_commint)
            datas=(book_name, book_url, book_img, book_price, book_commint)
            print(info)
            save_data(info)
        time.sleep(2)

        next_page = driver.find_element_by_partial_link_text('下一页')
        time.sleep(3)
        next_page.click()
        time.sleep(3)
        get_book(driver)
    except Exception as e:
        print("哎呀....糟糕，被发现了.. ")
        print("故障原因: %s" % e)
    finally:
        pass

def save_data(datas):
    """
    数据持久化保存 到本地csv文件
    :param datas:
    :return:
    """
    with open('data.txt', 'a', encoding='utf8', newline='') as f:
        f.write(datas)


if __name__ == '__main__':

    time.sleep(2)
    keywords = input("请输入搜索关键字:")
    print("需要搜索的关键字是:%s" % keywords)
    print("请稍后.....")
    get_addr(url='https://www.jd.com/', keywords=keywords)
